// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: database.proto
#ifndef GRPC_database_2eproto__INCLUDED
#define GRPC_database_2eproto__INCLUDED

#include "database.pb.h"

#include <functional>
#include <grpc/impl/codegen/port_platform.h>
#include <grpcpp/impl/codegen/async_generic_service.h>
#include <grpcpp/impl/codegen/async_stream.h>
#include <grpcpp/impl/codegen/async_unary_call.h>
#include <grpcpp/impl/codegen/client_callback.h>
#include <grpcpp/impl/codegen/client_context.h>
#include <grpcpp/impl/codegen/completion_queue.h>
#include <grpcpp/impl/codegen/message_allocator.h>
#include <grpcpp/impl/codegen/method_handler.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/server_callback.h>
#include <grpcpp/impl/codegen/server_callback_handlers.h>
#include <grpcpp/impl/codegen/server_context.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace mascot {

class Directory final {
 public:
  static constexpr char const* service_full_name() {
    return "mascot.Directory";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    virtual ::grpc::Status ExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::mascot::DirectoryReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>> AsyncExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>>(AsyncExportDeviceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>> PrepareAsyncExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>>(PrepareAsyncExportDeviceRaw(context, request, cq));
    }
    virtual ::grpc::Status ExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::mascot::DirectoryReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>> AsyncExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>>(AsyncExportDevicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>> PrepareAsyncExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>>(PrepareAsyncExportDevicesRaw(context, request, cq));
    }
    virtual ::grpc::Status ImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::mascot::DirectoryImportReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryImportReply>> AsyncImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryImportReply>>(AsyncImportDeviceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryImportReply>> PrepareAsyncImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryImportReply>>(PrepareAsyncImportDeviceRaw(context, request, cq));
    }
    class experimental_async_interface {
     public:
      virtual ~experimental_async_interface() {}
      virtual void ExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo* request, ::mascot::DirectoryReply* response, std::function<void(::grpc::Status)>) = 0;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      virtual void ExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo* request, ::mascot::DirectoryReply* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      #else
      virtual void ExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo* request, ::mascot::DirectoryReply* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      #endif
      virtual void ExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos* request, ::mascot::DirectoryReply* response, std::function<void(::grpc::Status)>) = 0;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      virtual void ExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos* request, ::mascot::DirectoryReply* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      #else
      virtual void ExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos* request, ::mascot::DirectoryReply* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      #endif
      virtual void ImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName* request, ::mascot::DirectoryImportReply* response, std::function<void(::grpc::Status)>) = 0;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      virtual void ImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName* request, ::mascot::DirectoryImportReply* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      #else
      virtual void ImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName* request, ::mascot::DirectoryImportReply* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      #endif
    };
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    typedef class experimental_async_interface async_interface;
    #endif
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    async_interface* async() { return experimental_async(); }
    #endif
    virtual class experimental_async_interface* experimental_async() { return nullptr; }
  private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>* AsyncExportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>* PrepareAsyncExportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>* AsyncExportDevicesRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>* PrepareAsyncExportDevicesRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryImportReply>* AsyncImportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryImportReply>* PrepareAsyncImportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel);
    ::grpc::Status ExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::mascot::DirectoryReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>> AsyncExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>>(AsyncExportDeviceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>> PrepareAsyncExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>>(PrepareAsyncExportDeviceRaw(context, request, cq));
    }
    ::grpc::Status ExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::mascot::DirectoryReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>> AsyncExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>>(AsyncExportDevicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>> PrepareAsyncExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>>(PrepareAsyncExportDevicesRaw(context, request, cq));
    }
    ::grpc::Status ImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::mascot::DirectoryImportReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryImportReply>> AsyncImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryImportReply>>(AsyncImportDeviceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryImportReply>> PrepareAsyncImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryImportReply>>(PrepareAsyncImportDeviceRaw(context, request, cq));
    }
    class experimental_async final :
      public StubInterface::experimental_async_interface {
     public:
      void ExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo* request, ::mascot::DirectoryReply* response, std::function<void(::grpc::Status)>) override;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      void ExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo* request, ::mascot::DirectoryReply* response, ::grpc::ClientUnaryReactor* reactor) override;
      #else
      void ExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo* request, ::mascot::DirectoryReply* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      #endif
      void ExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos* request, ::mascot::DirectoryReply* response, std::function<void(::grpc::Status)>) override;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      void ExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos* request, ::mascot::DirectoryReply* response, ::grpc::ClientUnaryReactor* reactor) override;
      #else
      void ExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos* request, ::mascot::DirectoryReply* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      #endif
      void ImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName* request, ::mascot::DirectoryImportReply* response, std::function<void(::grpc::Status)>) override;
      #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      void ImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName* request, ::mascot::DirectoryImportReply* response, ::grpc::ClientUnaryReactor* reactor) override;
      #else
      void ImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName* request, ::mascot::DirectoryImportReply* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      #endif
     private:
      friend class Stub;
      explicit experimental_async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class experimental_async_interface* experimental_async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class experimental_async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>* AsyncExportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>* PrepareAsyncExportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>* AsyncExportDevicesRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>* PrepareAsyncExportDevicesRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryImportReply>* AsyncImportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryImportReply>* PrepareAsyncImportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ExportDevice_;
    const ::grpc::internal::RpcMethod rpcmethod_ExportDevices_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportDevice_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    virtual ::grpc::Status ExportDevice(::grpc::ServerContext* context, const ::mascot::DbDevExportInfo* request, ::mascot::DirectoryReply* response);
    virtual ::grpc::Status ExportDevices(::grpc::ServerContext* context, const ::mascot::DbDevExportInfos* request, ::mascot::DirectoryReply* response);
    virtual ::grpc::Status ImportDevice(::grpc::ServerContext* context, const ::mascot::DeviceName* request, ::mascot::DirectoryImportReply* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ExportDevice() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ExportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevice(::grpc::ServerContext* /*context*/, const ::mascot::DbDevExportInfo* /*request*/, ::mascot::DirectoryReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportDevice(::grpc::ServerContext* context, ::mascot::DbDevExportInfo* request, ::grpc::ServerAsyncResponseWriter< ::mascot::DirectoryReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportDevices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ExportDevices() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ExportDevices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevices(::grpc::ServerContext* /*context*/, const ::mascot::DbDevExportInfos* /*request*/, ::mascot::DirectoryReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportDevices(::grpc::ServerContext* context, ::mascot::DbDevExportInfos* request, ::grpc::ServerAsyncResponseWriter< ::mascot::DirectoryReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportDevice() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ImportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportDevice(::grpc::ServerContext* /*context*/, const ::mascot::DeviceName* /*request*/, ::mascot::DirectoryImportReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportDevice(::grpc::ServerContext* context, ::mascot::DeviceName* request, ::grpc::ServerAsyncResponseWriter< ::mascot::DirectoryImportReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ExportDevice<WithAsyncMethod_ExportDevices<WithAsyncMethod_ImportDevice<Service > > > AsyncService;
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_ExportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_ExportDevice() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::mascot::DbDevExportInfo, ::mascot::DirectoryReply>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::mascot::DbDevExportInfo* request, ::mascot::DirectoryReply* response) { return this->ExportDevice(context, request, response); }));}
    void SetMessageAllocatorFor_ExportDevice(
        ::grpc::experimental::MessageAllocator< ::mascot::DbDevExportInfo, ::mascot::DirectoryReply>* allocator) {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
    #else
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::experimental().GetHandler(0);
    #endif
      static_cast<::grpc::internal::CallbackUnaryHandler< ::mascot::DbDevExportInfo, ::mascot::DirectoryReply>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_ExportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevice(::grpc::ServerContext* /*context*/, const ::mascot::DbDevExportInfo* /*request*/, ::mascot::DirectoryReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* ExportDevice(
      ::grpc::CallbackServerContext* /*context*/, const ::mascot::DbDevExportInfo* /*request*/, ::mascot::DirectoryReply* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* ExportDevice(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::mascot::DbDevExportInfo* /*request*/, ::mascot::DirectoryReply* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_ExportDevices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_ExportDevices() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::mascot::DbDevExportInfos, ::mascot::DirectoryReply>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::mascot::DbDevExportInfos* request, ::mascot::DirectoryReply* response) { return this->ExportDevices(context, request, response); }));}
    void SetMessageAllocatorFor_ExportDevices(
        ::grpc::experimental::MessageAllocator< ::mascot::DbDevExportInfos, ::mascot::DirectoryReply>* allocator) {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
    #else
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::experimental().GetHandler(1);
    #endif
      static_cast<::grpc::internal::CallbackUnaryHandler< ::mascot::DbDevExportInfos, ::mascot::DirectoryReply>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_ExportDevices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevices(::grpc::ServerContext* /*context*/, const ::mascot::DbDevExportInfos* /*request*/, ::mascot::DirectoryReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* ExportDevices(
      ::grpc::CallbackServerContext* /*context*/, const ::mascot::DbDevExportInfos* /*request*/, ::mascot::DirectoryReply* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* ExportDevices(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::mascot::DbDevExportInfos* /*request*/, ::mascot::DirectoryReply* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_ImportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_ImportDevice() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::mascot::DeviceName, ::mascot::DirectoryImportReply>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::mascot::DeviceName* request, ::mascot::DirectoryImportReply* response) { return this->ImportDevice(context, request, response); }));}
    void SetMessageAllocatorFor_ImportDevice(
        ::grpc::experimental::MessageAllocator< ::mascot::DeviceName, ::mascot::DirectoryImportReply>* allocator) {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
    #else
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::experimental().GetHandler(2);
    #endif
      static_cast<::grpc::internal::CallbackUnaryHandler< ::mascot::DeviceName, ::mascot::DirectoryImportReply>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_ImportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportDevice(::grpc::ServerContext* /*context*/, const ::mascot::DeviceName* /*request*/, ::mascot::DirectoryImportReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* ImportDevice(
      ::grpc::CallbackServerContext* /*context*/, const ::mascot::DeviceName* /*request*/, ::mascot::DirectoryImportReply* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* ImportDevice(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::mascot::DeviceName* /*request*/, ::mascot::DirectoryImportReply* /*response*/)
    #endif
      { return nullptr; }
  };
  #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
  typedef ExperimentalWithCallbackMethod_ExportDevice<ExperimentalWithCallbackMethod_ExportDevices<ExperimentalWithCallbackMethod_ImportDevice<Service > > > CallbackService;
  #endif

  typedef ExperimentalWithCallbackMethod_ExportDevice<ExperimentalWithCallbackMethod_ExportDevices<ExperimentalWithCallbackMethod_ImportDevice<Service > > > ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ExportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ExportDevice() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ExportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevice(::grpc::ServerContext* /*context*/, const ::mascot::DbDevExportInfo* /*request*/, ::mascot::DirectoryReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ExportDevices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ExportDevices() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ExportDevices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevices(::grpc::ServerContext* /*context*/, const ::mascot::DbDevExportInfos* /*request*/, ::mascot::DirectoryReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportDevice() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ImportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportDevice(::grpc::ServerContext* /*context*/, const ::mascot::DeviceName* /*request*/, ::mascot::DirectoryImportReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ExportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ExportDevice() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ExportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevice(::grpc::ServerContext* /*context*/, const ::mascot::DbDevExportInfo* /*request*/, ::mascot::DirectoryReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportDevice(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ExportDevices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ExportDevices() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ExportDevices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevices(::grpc::ServerContext* /*context*/, const ::mascot::DbDevExportInfos* /*request*/, ::mascot::DirectoryReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportDevices(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportDevice() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ImportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportDevice(::grpc::ServerContext* /*context*/, const ::mascot::DeviceName* /*request*/, ::mascot::DirectoryImportReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportDevice(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_ExportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_ExportDevice() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ExportDevice(context, request, response); }));
    }
    ~ExperimentalWithRawCallbackMethod_ExportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevice(::grpc::ServerContext* /*context*/, const ::mascot::DbDevExportInfo* /*request*/, ::mascot::DirectoryReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* ExportDevice(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* ExportDevice(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_ExportDevices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_ExportDevices() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ExportDevices(context, request, response); }));
    }
    ~ExperimentalWithRawCallbackMethod_ExportDevices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevices(::grpc::ServerContext* /*context*/, const ::mascot::DbDevExportInfos* /*request*/, ::mascot::DirectoryReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* ExportDevices(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* ExportDevices(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_ImportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_ImportDevice() {
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
      ::grpc::Service::
    #else
      ::grpc::Service::experimental().
    #endif
        MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
                   ::grpc::CallbackServerContext*
    #else
                   ::grpc::experimental::CallbackServerContext*
    #endif
                     context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportDevice(context, request, response); }));
    }
    ~ExperimentalWithRawCallbackMethod_ImportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportDevice(::grpc::ServerContext* /*context*/, const ::mascot::DeviceName* /*request*/, ::mascot::DirectoryImportReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    #ifdef GRPC_CALLBACK_API_NONEXPERIMENTAL
    virtual ::grpc::ServerUnaryReactor* ImportDevice(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #else
    virtual ::grpc::experimental::ServerUnaryReactor* ImportDevice(
      ::grpc::experimental::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)
    #endif
      { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ExportDevice() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::mascot::DbDevExportInfo, ::mascot::DirectoryReply>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::mascot::DbDevExportInfo, ::mascot::DirectoryReply>* streamer) {
                       return this->StreamedExportDevice(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ExportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportDevice(::grpc::ServerContext* /*context*/, const ::mascot::DbDevExportInfo* /*request*/, ::mascot::DirectoryReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportDevice(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::DbDevExportInfo,::mascot::DirectoryReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportDevices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ExportDevices() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::mascot::DbDevExportInfos, ::mascot::DirectoryReply>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::mascot::DbDevExportInfos, ::mascot::DirectoryReply>* streamer) {
                       return this->StreamedExportDevices(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ExportDevices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportDevices(::grpc::ServerContext* /*context*/, const ::mascot::DbDevExportInfos* /*request*/, ::mascot::DirectoryReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportDevices(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::DbDevExportInfos,::mascot::DirectoryReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportDevice() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::mascot::DeviceName, ::mascot::DirectoryImportReply>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::mascot::DeviceName, ::mascot::DirectoryImportReply>* streamer) {
                       return this->StreamedImportDevice(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportDevice(::grpc::ServerContext* /*context*/, const ::mascot::DeviceName* /*request*/, ::mascot::DirectoryImportReply* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportDevice(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::DeviceName,::mascot::DirectoryImportReply>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ExportDevice<WithStreamedUnaryMethod_ExportDevices<WithStreamedUnaryMethod_ImportDevice<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ExportDevice<WithStreamedUnaryMethod_ExportDevices<WithStreamedUnaryMethod_ImportDevice<Service > > > StreamedService;
};

}  // namespace mascot


#endif  // GRPC_database_2eproto__INCLUDED
